
// PTP-2AxisDlg.cpp :  
//

#include "stdafx.h"
#include "PTP-2Axis.h"
#include "PTP-2AxisDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//--------------------------------------
#include "LCOM.h"
#pragma comment(lib, "LCOM.lib")
//--------------------------------------


class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// ȭ  Դϴ.
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

// Դϴ.
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CPTP2AxisDlg ȭ 
#define NODE_CNT 3

typedef struct PTPPacketInfoSt
{
	signed long Pos; 
	signed long Pos2;
	unsigned long Vel;
	unsigned long Acc;
	unsigned long Dec; 
	unsigned long Stop_dec;
	
} PTP_PACKETINFO;

PTP_PACKETINFO PTP_Packet[NODE_CNT];
int m_DriveId[NODE_CNT];
int m_Slave_State[NODE_CNT];
static int TimeCNT = 0;
static int TimeCNT2 = 0;
static int TimeCNT3 = 0;
CPTP2AxisDlg::CPTP2AxisDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_PTP2Axis_DIALOG, pParent)
	, m_Pos(0)
	, m_Vel(0)
	, m_Acc(0)
	, m_Dec(0)
	, m_StopDec(0)
	, m_Pos2(0)
	, m_DwellTime(0)
	, m_Vel2(0)
	, m_Acc2(0)
	, m_Dec2(0)
	, m_DwellTime2(0)
	, m_StopDec2(0)
	, m_edit_SetPOS(0)
	, m_edit_SetPOS2(0)
	, m_Pos_axis2(0)
	, m_Pos3(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bSDrvOnline = b_TargetSW = b_TargetSW2 = b_checkReverse = b_MOVEState = b_checkReverse2= FALSE;
	
}

void CPTP2AxisDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_NODEID, m_edit_driveId);
	DDX_Control(pDX, IDC_EDIT_NODEID2, m_edit_driveId2);
	
	DDX_Control(pDX, IDC_EDIT_TARGETIP, m_edit_targetIp);
	DDX_Control(pDX, IDC_EDIT_TARGETIP2, m_edit_targetIp2);
	DDX_Control(pDX, IDC_EDIT_TARGETPORT, m_edit_targetPort);
	
	
	DDX_Text(pDX, IDC_EDIT_TARGETPOS, m_Pos);
	DDX_Text(pDX, IDC_EDIT_PROGILE_VEL, m_Vel);
	DDX_Text(pDX, IDC_EDIT_PROGILE_ACC, m_Acc);
	DDX_Text(pDX, IDC_EDIT_PROGILE_DEC, m_Dec);
	DDX_Text(pDX, IDC_EDIT_STOP_DEC, m_StopDec);
	DDX_Text(pDX, IDC_EDIT_TARGETPOS2, m_Pos2);
	DDX_Text(pDX, IDC_EDIT5, m_DwellTime);
	DDX_Text(pDX, IDC_EDIT_SETPOS, m_edit_SetPOS);

	DDX_Text(pDX, IDC_EDIT2, m_Pos_axis2);
	DDX_Text(pDX, IDC_EDIT_PROGILE_VEL2, m_Vel2);
	DDX_Text(pDX, IDC_EDIT_PROGILE_ACC2, m_Acc2);
	DDX_Text(pDX, IDC_EDIT_PROGILE_DEC2, m_Dec2);
	DDX_Text(pDX, IDC_EDIT_STOP_DEC2, m_StopDec2);
	DDX_Text(pDX, IDC_EDIT_TARGETPOS3, m_Pos3);
	DDX_Text(pDX, IDC_EDIT7, m_DwellTime2);
	DDX_Text(pDX, IDC_EDIT_SETPOS2, m_edit_SetPOS2);


	DDX_Control(pDX, IDC_STATIC_AXIS1, m_MSG_AXIS1);
	DDX_Control(pDX, IDC_STATIC_AXIS2, m_MSG_AXIS2);

	DDX_Control(pDX, IDC_STATIC_MSG2, m_Msg_Version);

	DDX_Control(pDX, IDC_STATIC_MSG3, m_static_alarmMsg);
	DDX_Control(pDX, IDC_STATIC_MSG5, m_static_alarmMsg3);



}

BEGIN_MESSAGE_MAP(CPTP2AxisDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SERVO_ON, &CPTP2AxisDlg::OnBnClickedButtonServoOn)
	ON_BN_CLICKED(IDC_BUTTON_SERVO_OFF, &CPTP2AxisDlg::OnBnClickedButtonServoOff)
	ON_BN_CLICKED(IDC_BUTTON_MOVE, &CPTP2AxisDlg::OnBnClickedButtonMove)
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CPTP2AxisDlg::OnBnClickedButtonStop)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK, &CPTP2AxisDlg::OnBnClickedCheck)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_SERVO_ON2, &CPTP2AxisDlg::OnBnClickedButtonServoOn2)
	ON_BN_CLICKED(IDC_BUTTON_SERVO_OFF2, &CPTP2AxisDlg::OnBnClickedButtonServoOff2)
	ON_BN_CLICKED(IDC_CHECK2, &CPTP2AxisDlg::OnBnClickedCheck2)
	ON_BN_CLICKED(IDC_BUTTON_SETPOS, &CPTP2AxisDlg::OnBnClickedButtonSetpos)
	ON_BN_CLICKED(IDC_BUTTON_SETPOS2, &CPTP2AxisDlg::OnBnClickedButtonSetpos2)
	ON_BN_CLICKED(IDC_BUTTON2, &CPTP2AxisDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON_EDRV_CONNECT, &CPTP2AxisDlg::OnBnClickedButtonEdrvConnect)
	ON_BN_CLICKED(IDC_BUTTON_EDRV_CLOSE, &CPTP2AxisDlg::OnBnClickedButtonEdrvClose)
	ON_BN_CLICKED(IDC_BTN_PTP_READ, &CPTP2AxisDlg::OnBnClickedBtnPtpRead)
	ON_BN_CLICKED(IDC_BUTTON_SERVO_MOVE, &CPTP2AxisDlg::OnBnClickedButtonServoMove)
	ON_BN_CLICKED(IDC_BUTTON_SERVO_MOVE2, &CPTP2AxisDlg::OnBnClickedButtonServoMove2)
END_MESSAGE_MAP()


// CPTP2AxisDlg ޽ ó

BOOL CPTP2AxisDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ý ޴ "..." ޴ ׸ ߰մϴ.

	// IDM_ABOUTBOX ý   ־ մϴ.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	//  ȭ   մϴ.   α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.
	///////////////////////////////////////////////////////////////////////////////
	CString s;
	
    ///////////////////////////////////////////////////////////////////////////
	//Ethernet 
	m_edit_targetIp.SetWindowText("192.168.5.5");
	m_edit_targetIp2.SetWindowText("192.168.5.6");
	m_edit_targetPort.SetWindowText("502");
	m_edit_driveId.SetWindowText("1");
	m_edit_driveId2.SetWindowText("2");

	////////////////////////////////////////////////////////////////////////////
	
	//////////////////////////////////////////////////////////////////////////////////////////////////
	//DLL Version display
	CString str;
	int ret, pVersion;

	ret = LCOM_GetLcomDllVersion(&pVersion);
	str.Format("DLL Version = %d.%d.%d.%d",pVersion >> 24, (pVersion & 0x00FF0000) >> 16
		                                  , (pVersion & 0x0000FF00) >> 8, pVersion & 0x000000FF);
	m_Msg_Version.SetWindowText(str);

	//////////////////////////////////////////////////////////////////////////////////////////////////
	int pRxTimeout, pConnectionTimeout;
	ret = LCOM_SetTimeout(3, 1);
	ret = LCOM_GetTimeout(&pRxTimeout, &pConnectionTimeout);
	//////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////

	change_v = 0;
	data_first = 0;
	
	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

void CPTP2AxisDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ.  /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CPTP2AxisDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮԴϴ.

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CPTP2AxisDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CPTP2AxisDlg::OnBnClickedButtonMove()
{
	int ret,Mode;
	signed long Pos,Pos2,Pos3, Pos4;
	unsigned long Vel, Acc, Dec,Vel2, Acc2,Dec2;
	CString str;
	UpdateData();

	Mode = 1;
	Pos = m_Pos;
	Pos2 = m_Pos2;
	Pos3 = m_Pos3;
	Pos4 = m_Pos4;
	Vel = m_Vel;
	Acc = m_Acc;
	Dec = m_Dec;

	Vel2 = m_Vel2;
	Acc2 = m_Acc2;
	Dec2 = m_Dec2;


	b_MOVEState = 1;
	
	if (m_Slave_State[0]) ret = LCOM_SetOperationMode(m_DriveId[0], Mode);
	if (m_Slave_State[1]) ret = LCOM_SetOperationMode(m_DriveId[1], Mode);
	
	if(m_Slave_State[0] && b_TargetSW)  LCOM_MoveAbsolute(m_DriveId[0], Pos2, Vel, Acc, Dec);
	else ret = LCOM_MoveAbsolute(m_DriveId[0], Pos, Vel, Acc, Dec);

	if (m_Slave_State[1] && b_TargetSW2) ret = LCOM_MoveAbs(m_DriveId[1], Pos3);
	else ret = LCOM_MoveAbsolute(m_DriveId[1], Pos4, Vel2, Acc2, Dec2); 

}


void CPTP2AxisDlg::OnBnClickedButtonStop()
{
	int ret;
	unsigned long StopDec;
	UpdateData();

	StopDec = m_StopDec;

	if (m_Slave_State[0]) {
		ret = LCOM_StopDecel(m_DriveId[0], StopDec);
		ret = LCOM_Stop(m_DriveId[0]);
	}
	if (m_Slave_State[1]) {
		ret = LCOM_StopDecel(m_DriveId[1], StopDec);
		ret = LCOM_Stop(m_DriveId[1]);
	}

	b_MOVEState = 0;
}


void CPTP2AxisDlg::OnTimer(UINT_PTR nIDEvent)
{
	int ret,State,State2, State3, mode;
	long Pos, Pos2, Pos3;
	CString s;
	

	if (nIDEvent == 1)
	{
		//KillTimer(1); 
		timer_cnt++;
		
		if (timer_cnt >= 1) // 100ms
		{
			timer_cnt = 0;

			if (m_Slave_State[0]) {
				ret = LCOM_ActualPosition(m_DriveId[0], &Pos);
				s.Format("%ld", Pos);
				SetDlgItemText(IDC_EDIT_ACTUALPOSITION, s);

				ret = LCOM_IsInPosition(m_DriveId[0], &State);
				s.Format("%ld", State);
				SetDlgItemText(IDC_EDIT6, s);


			}

			if (m_Slave_State[1]) {
				ret = LCOM_ActualPosition(m_DriveId[1], &Pos2);
				s.Format("%ld", Pos2);
				SetDlgItemText(IDC_EDIT_ACTUALPOSITION2, s);

				ret = LCOM_IsInPosition(m_DriveId[1], &State2);
				s.Format("%ld", State2);
				SetDlgItemText(IDC_EDIT8, s);

			}

			if (b_MOVEState && State && b_checkReverse)
			{

				if (TimeCNT >= m_DwellTime / 100) {
					b_TargetSW = ~b_TargetSW;
					TimeCNT = 0;
					OnBnClickedButtonServoMove();

				}
				else
					TimeCNT++;
			}
			if (b_MOVEState2 && State2 && b_checkReverse2)
			{

				if (TimeCNT2 >= m_DwellTime2 / 100) {
					b_TargetSW2 = ~b_TargetSW2;
					TimeCNT2 = 0;
					OnBnClickedButtonServoMove2();

				}
				else
					TimeCNT2++;
			}
			
		}

		///////////////////////////////////////////////////////////////////////////////////
		/*Alarm code*/
		char Alarmbuf[256] = { 0 };
		int  AlarmState;
		unsigned short AlarmCode;
		if (m_Slave_State[0]) {
			ret = LCOM_IsAlarm(m_DriveId[0], &AlarmState, &AlarmCode);
			if (AlarmState) {
				s.Format("AlarmCode= %X)", AlarmCode);
				ret = LCOM_GetAlarmHistory(m_DriveId[0], 1, Alarmbuf);

				s.Format("AlarmList= %s", Alarmbuf);
				m_static_alarmMsg.SetWindowText(s);
			}
		}
		if (m_Slave_State[1]) {
			ret = LCOM_IsAlarm(m_DriveId[1], &AlarmState, &AlarmCode);
			if (AlarmState) {
				s.Format("AlarmCode= %X)", AlarmCode);
				ret = LCOM_GetAlarmHistory(m_DriveId[1], 1, Alarmbuf);

				s.Format("AlarmList= %s", Alarmbuf);
				m_static_alarmMsg3.SetWindowText(s);
			}
		}
		///////////////////////////////////////////////////////////////////////////////////


	}

	//SetTimer(1, 100, NULL);
	CDialogEx::OnTimer(nIDEvent);
}

BOOL CPTP2AxisDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN && (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE))
	{
		return TRUE;
	}

	return CDialogEx::PreTranslateMessage(pMsg);
}


void CPTP2AxisDlg::OnBnClickedCheck()
{
	b_checkReverse = IsDlgButtonChecked(IDC_CHECK);
}


void CPTP2AxisDlg::OnDestroy()
{
	if (pFile != NULL) fclose(pFile);
	CDialogEx::OnDestroy();

	
}
void CPTP2AxisDlg::OnBnClickedButtonServoOn()
{
	int ret;

	if (m_Slave_State[0]) {
		if (m_Slave_State[0]) ret = LCOM_SetOperationMode(m_DriveId[0], 1);
		ret = LCOM_Enable(m_DriveId[0]);
	}
	GetDlgItem(IDC_BUTTON_MOVE)->EnableWindow(true);
}


void CPTP2AxisDlg::OnBnClickedButtonServoOff()
{
	int ret;

	if (m_Slave_State[0]) {
		ret = LCOM_Disable(m_DriveId[0]);
	}

	b_MOVEState = 0;
	GetDlgItem(IDC_BUTTON_MOVE)->EnableWindow(false);
}

void CPTP2AxisDlg::OnBnClickedButtonServoOn2()
{
	int ret;

	if (m_Slave_State[1]) {
		if (m_Slave_State[1]) ret = LCOM_SetOperationMode(m_DriveId[1], 1);
		ret = LCOM_Enable(m_DriveId[1]);
	}
	GetDlgItem(IDC_BUTTON_MOVE)->EnableWindow(true);
}


void CPTP2AxisDlg::OnBnClickedButtonServoOff2()
{
	int ret;

	if (m_Slave_State[1]) {
		ret = LCOM_Disable(m_DriveId[1]);
	}

	b_MOVEState = 0;
	GetDlgItem(IDC_BUTTON_MOVE)->EnableWindow(false);
}


void CPTP2AxisDlg::OnBnClickedCheck2()
{
	b_checkReverse2 = IsDlgButtonChecked(IDC_CHECK2);
}

void CPTP2AxisDlg::OnBnClickedButtonSetpos()
{
	int ret;
	long HomeOffset;
	UpdateData();

	HomeOffset = m_edit_SetPOS;

	ret = LCOM_SetCurrentPosition(m_DriveId[0], HomeOffset);

}


void CPTP2AxisDlg::OnBnClickedButtonSetpos2()
{
	int ret;
	long HomeOffset;
	UpdateData();

	HomeOffset = m_edit_SetPOS2;

	ret = LCOM_SetCurrentPosition(m_DriveId[1], HomeOffset);
}


void CPTP2AxisDlg::OnBnClickedButton2()
{
	int  ret;
	// m_DriveId[0] slave ˶ 
	ret = LCOM_ResetAlarm(m_DriveId[0]);
	// m_DriveId[1] slave ˶ 
	ret = LCOM_ResetAlarm(m_DriveId[1]);
	// m_DriveId[1] slave ˶ 
	ret = LCOM_ResetAlarm(m_DriveId[2]);
}

void CPTP2AxisDlg::OnBnClickedButtonEdrvConnect()
{
	CWaitCursor cursor;

	int ret, LibVersion, Port, cnt;
	CString s;
	UpdateData();
	//---lib test
	ret = LCOM_GetLcomDllVersion(&LibVersion);
	//---Drive id, IpAddress, PortNum
	m_edit_driveId.GetWindowText(s);
	m_DriveId[0] = atoi(s);
	m_edit_targetPort.GetWindowText(s);

	Port = atoi(s);
	m_edit_targetIp.GetWindowText(s);
	wsprintf(cIp, "%s", s);
	m_edit_targetIp2.GetWindowText(s);
	wsprintf(cIp2, "%s", s);

	m_edit_driveId2.GetWindowText(s);
	m_DriveId[1] = atoi(s);


	ret = LCOM_TCPOpen(m_DriveId[0], cIp, Port);
	ret = LCOM_TCPOpen(m_DriveId[1], cIp2, Port);

	OnBnClickedBtnPtpRead();
 }


void CPTP2AxisDlg::OnBnClickedButtonEdrvClose()
{
	int ret = 0;
	CString s;
	ret = LCOM_DriveClose(m_DriveId[0]);
	ret = LCOM_DriveClose(m_DriveId[1]);

	//---------------------------------------------
	char cbuf[256] = { 0 };

	/*  slave Ʈũ ¸ ȯ*/
	int State;
	ret = LCOM_IsSlaveOnline(m_DriveId[0], &State);
	if (State) m_MSG_AXIS1.SetWindowText("Connected");
	else m_MSG_AXIS1.SetWindowText("Disconnect");

	ret = LCOM_IsSlaveOnline(m_DriveId[1], &State);
	if (State) m_MSG_AXIS2.SetWindowText("Connected");
	else m_MSG_AXIS2.SetWindowText("Disconnect");

	/*----------------------------------------------------*/

	KillTimer(1);

}

void CPTP2AxisDlg::Check_Communication()
{
	int ret,cnt,mode;
	CString str,s;
	long Pos,Pos2;
	///////////////////////////////////////////////////////////////////////////////////////
	/*  slave Ʈũ ¸ ȯ*/
	str.Format("Connected");
	ret = LCOM_IsSlaveOnline(m_DriveId[0], &m_Slave_State[0]);
	if (m_Slave_State[0]) m_MSG_AXIS1.SetWindowText(str);

	ret = LCOM_IsSlaveOnline(m_DriveId[1], &m_Slave_State[1]);
	if (m_Slave_State[1]) m_MSG_AXIS2.SetWindowText(str);
	Sleep(200);

	ret = LCOM_ReadWordS(m_DriveId[0], 0x2630, 0, &backup_idexno);
	ret = LCOM_ReadWordS(m_DriveId[1], 0x2630, 0, &backup_idexno2);

	ret = LCOM_ReadWordS(m_DriveId[0], 0x2631, 0, &backup_data);
	ret = LCOM_ReadWordS(m_DriveId[1], 0x2631, 0, &backup_data2);

	
	
}
void CPTP2AxisDlg::PTP_Parameter_Read()
{
	UpdateData();
	int ret;
	long Pos;
	CString s;

	if (m_Slave_State[0]) {
		//1-Axis position data
		ret = LCOM_ReadDWordS(m_DriveId[0], 0x607A, 0x00, &PTP_Packet[0].Pos);
		m_Pos = PTP_Packet[0].Pos;
		// readvelocity command
		ret = LCOM_ReadDWord(m_DriveId[0], 0x6081, 0x00, &PTP_Packet[0].Vel);
		m_Vel = PTP_Packet[0].Vel;
		// read acc command
		ret = LCOM_ReadDWord(m_DriveId[0], 0x6083, 0x00, &PTP_Packet[0].Acc);
		m_Acc = PTP_Packet[0].Acc;
		// read dec command
		ret = LCOM_ReadDWord(m_DriveId[0], 0x6084, 0x00, &PTP_Packet[0].Dec);
		m_Dec = PTP_Packet[0].Dec;
		//read stop decel
		ret = LCOM_ReadDWord(m_DriveId[0], 0x6085, 0x00, &PTP_Packet[0].Stop_dec);
		m_StopDec = PTP_Packet[0].Stop_dec;
		//read actual position
		

	}

	if (m_Slave_State[1]) {
		//2-Axis position data
		ret = LCOM_ReadDWordS(m_DriveId[1], 0x607A, 0x00, &PTP_Packet[1].Pos);
		m_Pos_axis2 = PTP_Packet[1].Pos;
		// readvelocity command
		ret = LCOM_ReadDWord(m_DriveId[1], 0x6081, 0x00, &PTP_Packet[1].Vel);
		m_Vel2 = PTP_Packet[1].Vel;
		// read acc command
		ret = LCOM_ReadDWord(m_DriveId[1], 0x6083, 0x00, &PTP_Packet[1].Acc);
		m_Acc2 = PTP_Packet[1].Acc;
		// read dec command
		ret = LCOM_ReadDWord(m_DriveId[1], 0x6084, 0x00, &PTP_Packet[1].Dec);
		m_Dec2 = PTP_Packet[1].Dec;
		//read stop decel
		ret = LCOM_ReadDWord(m_DriveId[1], 0x6085, 0x00, &PTP_Packet[1].Stop_dec);
		m_StopDec2 = PTP_Packet[1].Stop_dec;
		//read actual position
		ret = LCOM_ActualPosition(m_DriveId[1], &Pos);
		s.Format("%ld", Pos);
		SetDlgItemText(IDC_EDIT_ACTUALPOSITION2, s);
	}
	UpdateData(false);
}
void CPTP2AxisDlg::OnBnClickedBtnPtpRead()
{
	int ret;
	CString str, s;

	Check_Communication();
	PTP_Parameter_Read();
	SetTimer(1, 100, NULL);
	

}

void CPTP2AxisDlg::OnBnClickedButtonServoMove()
{
	int ret, Mode;
	signed long Pos, Pos2, Pos3, Pos4;
	unsigned long Vel, Acc, Dec, Vel2, Acc2, Dec2;
	UpdateData();

	Mode = 1;
	Pos = m_Pos;
	Pos2 = m_Pos2;

	Vel = m_Vel;
	Acc = m_Acc;
	Dec = m_Dec;

	b_MOVEState = 1;

	if (m_Slave_State[0]) ret = LCOM_SetOperationMode(m_DriveId[0], Mode);

	if (m_Slave_State[0] && b_TargetSW && b_checkReverse)  ret = LCOM_MoveAbsolute(m_DriveId[0], Pos2, Vel, Acc, Dec);
	else ret = LCOM_MoveAbsolute(m_DriveId[0], Pos, Vel, Acc, Dec);
	
	if (ret)
		Mode = 1;
}


void CPTP2AxisDlg::OnBnClickedButtonServoMove2()
{
	int ret, Mode;
	signed long Pos, Pos2, Pos3, Pos4;
	unsigned long Vel, Acc, Dec, Vel2, Acc2, Dec2;
	UpdateData();

	Mode = 1;
	Pos = m_Pos_axis2;
	Pos2 = m_Pos3;

	Vel = m_Vel2;
	Acc = m_Acc2;
	Dec = m_Dec2;

	b_MOVEState2 = 1;

	if (m_Slave_State[1]) ret = LCOM_SetOperationMode(m_DriveId[1], Mode);

	if (m_Slave_State[1] && b_TargetSW2 && b_checkReverse)  LCOM_MoveAbsolute(m_DriveId[1], Pos2, Vel, Acc, Dec);
	else ret = LCOM_MoveAbsolute(m_DriveId[1], Pos, Vel, Acc, Dec);
}



